Index: HLFS/config
===================================================================
--- HLFS/config	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ HLFS/config	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -39,4 +39,5 @@
 #--- Book version
 LFSVRS=development
+TREE=trunk/BOOK
 
 #--- Name of the makefile
Index: HLFS/master.sh
===================================================================
--- HLFS/master.sh	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ HLFS/master.sh	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -120,10 +120,11 @@
     # Adjust 'name'
     case $name in
-      linux-libc) name=linux-libc-headers ;;
+      linux-libc) name="linux-libc-headers" ;;
+      gcc)        name="gcc-core"  ;;
+      uclibc)     name="uClibc"  ;;
     esac
 
     # Set the dependency for the first target.
     if [ -z $PREV ] ; then PREV=022-settingenvironment ; fi
-
 
     #--------------------------------------------------------------------#
@@ -137,20 +138,11 @@
     # Find the version of the command files, if it corresponds with the building of
     # a specific package
-    vrs=`grep "^$name-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-    # If $vrs isn't empty, we've got a package...
-    if [ "$vrs" != "" ] ; then
-      # Deal with non-standard names
-      case $name in
-        tcl)    FILE="$name$vrs-src.tar.*"  ;;
-        uclibc) FILE="uClibc-$vrs.tar.*"    ;;
-        gcc)    FILE="gcc-core-$vrs.tar.*"  ;;
-        *)      FILE="$name-$vrs.tar.*"     ;;
-      esac
+    pkg_tarball=$(get_package_tarball_name $name)
+    # If $pkg_tarball isn't empty, we've got a package...
+    if [ "$pkg_tarball" != "" ] ; then
       # Insert instructions for unpacking the package and to set the PKGDIR variable.
       case $this_script in
-        *binutils* )
-          wrt_unpack "$FILE" 1 ;; # Do not delete an existing package directories
-        *)
-          wrt_unpack "$FILE" ;;
+        *binutils* )  wrt_unpack "$pkg_tarball" 1 ;; # Do not delete an existing package directories
+        *)            wrt_unpack "$pkg_tarball" ;;
       esac
       # If the testsuites must be run, initialize the log file
@@ -181,10 +173,9 @@
     # (so we can review config.cache, config.log, etc.)
     # For Binutils the sources must be retained for some time.
-    if [ "$vrs" != "" ] ; then
+    if [ "$pkg_tarball" != "" ] ; then
       case "${this_script}" in
-        *binutils*) : # do NOTHING
-          ;;
-        *) wrt_remove_build_dirs "$name"
-          ;;
+        *binutils*) : ;;   # do NOTHING
+	*gcc*) wrt_remove_build_dirs "gcc"    ;;
+        *)     wrt_remove_build_dirs "$name"    ;;
       esac
     fi
@@ -272,9 +263,23 @@
     name=`echo $this_script | sed -e 's@[0-9]\{3\}-@@'`
 
+    #
+    # Sed replacement to fix some rm command that could fail.
+    # That should be fixed in the book sources.
+    #
+    case $name in
+      glibc)  sed 's/rm /rm -f /' -i chapter06$N/$this_script        ;;
+      gcc)    sed 's/rm /rm -f /' -i chapter06$N/$this_script        ;;
+    esac
+
+    case $name in
+      gcc)     name="gcc-core" ;;
+      uclibc)  name="uClibc"   ;;
+    esac
+
     # Find the version of the command files, if it corresponds with the building of
     # a specific package
-    vrs=`grep "^$name-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-
-    if [[ "$vrs" = "" ]] && [[ -n "$N" ]] ; then
+    pkg_tarball=$(get_package_tarball_name $name)
+
+    if [[ "$pkg_tarball" = "" ]] && [[ -n "$N" ]] ; then
       case "${this_script}" in
         *stripping*) ;;
@@ -291,16 +296,4 @@
     LOGS="$LOGS ${this_script}"
 
-    #
-    # Sed replacement to fix some rm command that could fail.
-    # That should be fixed in the book sources.
-    #
-    case $name in
-      glibc)
-          sed 's/rm /rm -f /' -i chapter06$N/$this_script
-        ;;
-      gcc)
-          sed 's/rm /rm -f /' -i chapter06$N/$this_script
-        ;;
-    esac
 
     #--------------------------------------------------------------------#
@@ -309,22 +302,15 @@
     #
     # Drop in the name of the target on a new line, and the previous target
-    # as a dependency. Also call the echo_message function.
+    # as a dependency. Also call the echo_message function.		
     wrt_target "${this_script}${N}" "$PREV"
 
-    # If $vrs isn't empty, we've got a package...
+    # If $pkg_tarball isn't empty, we've got a package...
     # Insert instructions for unpacking the package and changing directories
-    if [ "$vrs" != "" ] ; then
-      # Deal with non-standard names
-      case $name in
-        tcl)    FILE="$name$vrs-src.tar.*" ;;
-        uclibc) FILE="uClibc-$vrs.tar.*" ;;
-        gcc)    FILE="gcc-core-$vrs.tar.*" ;;
-        *)      FILE="$name-$vrs.tar.*" ;;
-      esac
-      wrt_unpack2 "$FILE"
+    if [ "$pkg_tarball" != "" ] ; then
+      wrt_unpack2 "$pkg_tarball"
       wrt_target_vars
       # If the testsuites must be run, initialize the log file
       case $name in
-        binutils | gcc | glibc )
+        binutils | gcc-core | glibc )
           [[ "$TEST" != "0" ]] && wrt_test_log2 "${this_script}"
           ;;
@@ -354,5 +340,5 @@
     #
     # Remove the build directory(ies) except if the package build fails.
-    if [ "$vrs" != "" ] ; then
+    if [ "$pkg_tarball" != "" ] ; then
       wrt_remove_build_dirs "$name"
     fi
@@ -428,9 +414,7 @@
     case "${this_script}" in
       *bootscripts*)
-        vrs=`grep "^lfs-bootscripts-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-        FILE="lfs-bootscripts-$vrs.tar.*"
-        wrt_unpack2 "$FILE"
-        vrs=`grep "^blfs-bootscripts-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-        echo -e "\t@echo \"\$(MOUNT_PT)\$(SRC)/blfs-bootscripts-$vrs\" >> sources-dir" >> $MKFILE.tmp
+        wrt_unpack2 $(get_package_tarball_name "lfs-bootscripts")
+        blfs_bootscripts=$(get_package_tarball_name "blfs-bootscripts" | sed -e 's/.tar.*//' )
+        echo -e "\t@echo \"\$(MOUNT_PT)\$(SRC)/$blfs_bootscripts\" >> sources-dir" >> $MKFILE.tmp
         ;;
     esac
@@ -547,4 +531,6 @@
 clean:  clean-chapter7 clean-chapter6 clean-chapter5 clean-chapter3
 
+restart: restart_code all
+
 clean-chapter3:
 	-if [ ! -f user-lfs-exist ]; then \\
@@ -600,4 +586,45 @@
 	fi;
 
+restart_code:
+	@echo ">>> This feature is experimental, BUGS may exist"	
+	
+	@if [ ! -L /tools ]; then \\
+	  echo -e "\\nERROR::\\n /tools is NOT a symlink.. /tools must point to \$(MOUNT_PT)/tools\\n" && false;\\
+	fi;
+	
+	@if [ ! -e /tools ]; then \\
+	  echo -e "\\nERROR::\\nThe target /tools points to does not exist.\\nVerify the target.. \$(MOUNT_PT)/tools\\n" && false;\\
+	fi;
+	
+	@if ! stat -c %N /tools | grep "\$(MOUNT_PT)/tools" >/dev/null ; then \\
+	  echo -e "\\nERROR::\\nThe symlink \\"/tools\\" does not point to \\"\$(MOUNT_PT)/tools\\".\\nCorrect the problem and rerun\\n" && false;\\
+	fi;	
+
+	@if [ -f ???-kernfs ]; then \\
+	  mkdir -pv \$(MOUNT_PT)/{proc,sys};\\
+	  if !  mount -l | "\$(MOUNT_PT)/dev" >/dev/null ; then \\
+	    mount -vt ramfs ramfs \$(MOUNT_PT)/dev;\\
+	  fi;\\
+	  if [ ! -e \$(MOUNT_PT)/dev/console ]; then \\
+	    mknod -m 600 \$(MOUNT_PT)/dev/console c 5 1;\\
+	  fi;\\
+	  if [ ! -e \$(MOUNT_PT)/dev/null ]; then \\
+	    mknod -m 666 \$(MOUNT_PT)/dev/null c 1 3;\\
+	  fi;\\
+	  if ! mount -l | grep "\$(MOUNT_PT)/dev/pts" >/dev/null ; then \\
+	    mount -vt devpts -o gid=4,mode=620 devpts \$(MOUNT_PT)/dev/pts;\\
+	  fi;\\
+	  if ! mount -l | grep "\$(MOUNT_PT)/dev/shm" >/dev/null ; then \\
+	    mount -vt tmpfs shm \$(MOUNT_PT)/dev/shm;\\
+	  fi;\\
+	  if ! mount -l | grep "\$(MOUNT_PT)/proc" >/dev/null ; then \\
+	    mount -vt proc proc \$(MOUNT_PT)/proc;\\
+	  fi;\\
+	  if ! mount -l | grep "\$(MOUNT_PT)/sys" >/dev/null ; then \\
+	    mount -vt sysfs sysfs \$(MOUNT_PT)/sys;\\
+	  fi;\\
+	fi;
+
+
 EOF
 ) >> $MKFILE
Index: LFS/config
===================================================================
--- LFS/config	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ LFS/config	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -11,8 +11,8 @@
 
 #--- Fully qualified path to a kernel config file
-# If no config file is  specified the kernel is NOT compiled
+# If no config file is specified the kernel is NOT compiled
 CONFIG=
 
-# Get the kernel package and patches even if no configutation file
+# Get the kernel package and patches even if no configuration file
 # has been supplied? 0(no)/1(yes)
 GETKERNEL=0
@@ -33,4 +33,5 @@
 #--- Book version
 LFSVRS=development
+TREE=trunk/BOOK
 
 #--- Name of the makefile
Index: LFS/master.sh
===================================================================
--- LFS/master.sh	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ LFS/master.sh	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -107,16 +107,10 @@
     # Find the version of the command files, if it corresponds with the building of
     # a specific package
-    vrs=`grep "^$name-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-
-    # If $vrs isn't empty, we've got a package...
-    if [ "$vrs" != "" ] ; then
-      if [ "$name" = "tcl" ] ; then
-        FILE="$name$vrs-src.tar.*"
-      else
-        FILE="$name-$vrs.tar.*"
-      fi
-
+    pkg_tarball=$(get_package_tarball_name $name)
+
+    # If $pkg_tarball isn't empty, we've got a package...
+    if [ "$pkg_tarball" != "" ] ; then
       # Insert instructions for unpacking the package and to set the PKGDIR variable.
-      wrt_unpack "$FILE"
+      wrt_unpack "$pkg_tarball"
       # If the testsuites must be run, initialize the log file
       [[ "$TEST" = "3" ]] && wrt_test_log "${this_script}"
@@ -135,5 +129,5 @@
     # Remove the build directory(ies) except if the package build fails
     # (so we can review config.cache, config.log, etc.)
-    if [ "$vrs" != "" ] ; then
+    if [ "$pkg_tarball" != "" ] ; then
       wrt_remove_build_dirs "$name"
     fi
@@ -196,7 +190,7 @@
     # a specific package. We need this here to can skip scripts not needed for
     # iterations rebuilds
-    vrs=`grep "^$name-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-
-    if [[ "$vrs" = "" ]] && [[ -n "$N" ]] ; then
+    pkg_tarball=$(get_package_tarball_name $name)
+
+    if [[ "$pkg_tarball" = "" ]] && [[ -n "$N" ]] ; then
       case "${this_script}" in
         *stripping*) ;;
@@ -221,9 +215,8 @@
     wrt_target "${this_script}${N}" "$PREV"
 
-    # If $vrs isn't empty, we've got a package...
+    # If $pkg_tarball isn't empty, we've got a package...
     # Insert instructions for unpacking the package and changing directories
-    if [ "$vrs" != "" ] ; then
-      FILE="$name-$vrs.tar.*"
-      wrt_unpack2 "$FILE"
+    if [ "$pkg_tarball" != "" ] ; then
+      wrt_unpack2 "$pkg_tarball"
       # If the testsuites must be run, initialize the log file
       case $name in
@@ -247,5 +240,5 @@
 
     # Remove the build directory(ies) except if the package build fails.
-    if [ "$vrs" != "" ] ; then
+    if [ "$pkg_tarball" != "" ] ; then
       wrt_remove_build_dirs "$name"
     fi
@@ -305,12 +298,12 @@
     case "${this_script}" in
       *bootscripts)
-          vrs=`grep "^lfs-bootscripts-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-          FILE="lfs-bootscripts-$vrs.tar.*"
-          wrt_unpack2 "$FILE"
+            name="lfs-bootscripts"
+            pkg_tarball=$(get_package_tarball_name $name)
+            wrt_unpack2 "$pkg_tarball"
         ;;
       *kernel)
-          vrs=`grep "^linux-version" $JHALFSDIR/packages | sed -e 's/.* //' -e 's/"//g'`
-          FILE="linux-$vrs.tar.*"
-          wrt_unpack2 "$FILE"
+            name="linux"
+            pkg_tarball=$(get_package_tarball_name $name)
+            wrt_unpack2 "$pkg_tarball"
        ;;
     esac
@@ -503,5 +496,5 @@
 	    mount -vt proc proc \$(MOUNT_PT)/proc;\\
 	  fi;\\
-	  if ! mount -l | grep "$\(MOUNT_PT)/sys" >/dev/null ; then \\
+	  if ! mount -l | grep "\$(MOUNT_PT)/sys" >/dev/null ; then \\
 	    mount -vt sysfs sysfs \$(MOUNT_PT)/sys;\\
 	  fi;\\
Index: README
===================================================================
--- README	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ README	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -5,5 +5,5 @@
      This collection of scripts, known as jhalfs-X, strives to create
   accurate makefiles from the Linux From Scratch book series XML files.
-  This software is an evolution of the original "jhalfs" code.
+  This software is an evolution of the original "jhalfs-0.2" code.
 
      The usage of this script assumes you have read and are familiar with
@@ -34,5 +34,14 @@
   supplied symlinks. After editing the config file for the project you wish
   to build, run the script.
-  
+
+     IMPORTANT:
+       If you use the switch -M (automatically run the generated makefile) you
+       must be 'root' or you can run the scripts using 'sudo'
+        i.e.  sudo ./lfs -G -M
+
+       If you want to run make manually you can only do so if you are 'root' or
+       via 'sudo'
+        i.e  (from within the jhalfs directory) sudo make
+
      The term <symlink> refers to the 1 of 3 package symlinks, lfs,hlfs,clfs.
      Replace <symlink> with your choice of packages; i.e.: ./lfs
@@ -51,4 +60,40 @@
      will give you a context sensitive list of command line switches.
 
+   >>>> an expanded example
+
+   export SRC_ARCHIVE=/mnt/SourceFiles
+
+   ./lfs -D /mnt/partition4 \
+         -K ~/jhalfs_configs/linux-2.6.16.19-LFS.config \
+	 -F ~/jhalfs-configs/fstab-sda3 \
+	 -G -T 0 -M
+
+   explanation:::
+
+   export SRC_ARCHIVE=/mnt/SourceFiles
+      # This points to a local archive of existing packages. If the version in
+        the archive is incorrect jhalfs will access the net and download the
+	necessary version and store it here for later use. DO NOT set this to
+	$BUILDDIR/sources. If you do not set this variable to a valid directory
+	ALL package tarballs will be downloaded from the 'net.
+
+   -D /mnt/partition4
+      # where everything takes place.  ..NOTE it must already exist and be mounted
+
+   -K ~/jhalfs_configs/linux-2.6.16.19-LFS.config
+      # If you want to automatically build a the kernel you MUST supply a valid
+        kernel configuration file. The file you supply will be copied and renamed.
+
+   -F ~/jhalfs-configs/fstab-sda3
+      # If you have a fstab file you wish to use it will be copied and renamed
+
+   -G   # Retrieve the package files. You MUST enable this flag at least once if you
+          wish to do a build or whenever you update the book.
+
+   -T 0 # don't run any testsuites
+
+   -M   # automatically run make against Makefile once jhalfs finishes its work.
+
+
 5. LAYOUT::
 
@@ -56,4 +101,8 @@
              /master.sh
              /xxxx.xsl
+
+        /CLFS2/config
+              /master.sh
+              /xxxx.xsl
 
         /HLFS/config
@@ -84,4 +133,5 @@
 
 	 ./clfs  ---|
+	 ./clfs2 ---|
 	 ./hlfs  ---|+---> master.sh
 	 ./lfs   ---|
@@ -89,11 +139,22 @@
 
 6. FAQ::
+    Q. "This 'help' file is very sparse"
+    A. Yes, it is. This tool, jhalfs, is for those who understand the LFS books
+       and wish to automate the build. 99% of any problems that arise can be
+       solved by reading the book(s).
+
     Q. "It doesn't work!"
     A. Yes it does, try ./lfs --help
 
+    Q. "It still doesn't work"
+    A. jhalfs was designed to work against the developement versions of the LFS
+       series of books. Consequently changes in a book(s) sometimes breaks older
+       versions of jhalfs. Before you start pulling out your hair download the
+       latest version of jhalfs to see if that solves your problem.
+
     Q. "How do I specify the build location?"
-    A. The original LFS document worked against the well know location /mnt/lfs.
+    A. The original LFS document worked against the well known location /mnt/lfs.
        This script automates the build of all of the LFS series of books and uses
-       a generic location $BUILDDIR with a default value a /mnt/build_dir.
+       a generic location $BUILDDIR with a default value of /mnt/build_dir.
        You may change this value to suit your needs.
 
@@ -110,8 +171,8 @@
     Q. "What is the function of the SRC_ARCHIVE variable?"
     A. When then symlinked master.sh runs it creates a local copy of the
-       necessary packages in BUILDDIR/sources by downloading the files. If 
-       the variable SRC_ARCHIVE is defined the software will first look in 
+       necessary packages in BUILDDIR/sources by downloading the files. If
+       the variable SRC_ARCHIVE is defined the software will first look in
        this location for the file and, if found, will copy it to BUILDDIR/sources.
-       If the files are not found in SRC_ARCHIVE _and_ you have write priv to 
+       If the files are not found in SRC_ARCHIVE _and_ you have write priv to
        the directory any downloaded files will be mirrored there.
 
@@ -120,10 +181,26 @@
        export SRC_ARCHIVE=/wherever/you/store/downloaded/packages
                        OR
-       you can change the setting in .common/config.
+       you can change the setting in common/config.
 
     Q. "Why have 2 copies of the files?"
-    A. The package files must be visible during the chroot phase and this is a 
+    A. The package files must be visible during the chroot phase and this is a
        simple and reliable method of doing so. This method also handles the CLFS
        build method where the final build may be done on a separate machine.
+
+    Q. "When I try to build 'xxx' with clfs the makefile fails at the mid-point"
+    A. There could be numerous reasons for the failure but the most likely reason
+       is you are doing a cross-build using the 'chroot' method and the target is
+       not compatible with the host.  If you choose to build using the chroot
+       method a test is performed at the end of the temptools phase. If the test
+       succeeds the build continues inside a chroot jail. However if the test fails
+       it means the host and target are not compatible an you should use the
+       'boot' method to create your target code.
+       As an extreme example: You can build a sparc target on a x86 platform but
+       only the temptools phase. You must run ./clfs using the 'boot' method and
+       not the 'chroot.' You must transfer the toolchain to a sparc platform, reboot
+       the sparc box and continue the build.
+       Of all the LFS series of books Cross-LFS requires the greatest
+       understanding of host/target hardware combination. Please read the book
+       carefully and don't skip the easy parts (there are none..)
 
 Authors:
Index: common/common-functions
===================================================================
--- common/common-functions	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ common/common-functions	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -53,6 +53,10 @@
 ${BOLD}  -B, --book VER${OFF}
         use VER version of the book as the system to build.
-        Supported versions are: dev*, trunk, SVN
-        These are aliases for the Development version of {C,H}LFS
+        Supported VER values are:
+          dev*, trunk, SVN = aliases for the Development version of {C,H}LFS
+          branch-NAME = a branch of name NAME
+          VERSION = the version of a stable released book
+        To know what branches and stable books work with this version of jhalfs
+        please see http://wiki.linuxfromscratch.org/alfs/wiki/SupportedBooks
 
 ${BOLD}  -D  --directory DIR${OFF}
@@ -84,5 +88,5 @@
         use the local working copy placed in DIR as the $(echo $PROGNAME | tr [a-z] [A-Z]) book
 
-${BOLD}  -C, --comparasion TYPE${OFF}
+${BOLD}  -C, --comparison TYPE${OFF}
          do iterative comparison analysis. This extends the total build time
          considerably because the entire final system will rebuild itself
@@ -91,5 +95,5 @@
            ICA   = do ICA as designed by Greg Schafer
            farce = do the farce analysis designed by Ken Moffat
-           both  = perfom both ICA and farce analysis
+           both  = perform both ICA and farce analysis
 
 ${BOLD}  -F, --fstab FILE${OFF}
@@ -105,5 +109,5 @@
 
 ${BOLD}  -R --rebuild${OFF}
-        clean the build directory before perfoming any other task. The directory
+        clean the build directory before performing any other task. The directory
         is cleaned only if it was populated by a previous jhalfs-X run.
 -EOF-
@@ -128,4 +132,16 @@
 -EOF-
 
+[[ ${PROGNAME} = "clfs2" ]] &&
+cat <<- -EOF-
+
+${BOLD}  -A, --arch ARCH ${OFF}
+        Select the TARGET architecture, valid selections are:
+           32bit builds
+        arm
+           64bit builds
+
+	64bit multi-lib
+-EOF-
+
 [[ ${PROGNAME} = "hlfs" ]] &&
 cat <<- -EOF-
@@ -208,4 +224,39 @@
 }
 
+
+#----------------------------------#
+wrt_target_boot() {                # Create target and initialize log file
+#----------------------------------#
+  local i=$1
+  local PREV=$2
+  case $i in
+    iteration* ) local LOGFILE=$this_script.log ;;
+             * ) local LOGFILE=$this_script ;;
+  esac
+(
+cat << EOF
+
+$i:  $PREV
+	@\$(call echo_message, Building)
+	@./progress_bar.sh \$@ &
+	@echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT}\`\n" >logs/$LOGFILE
+EOF
+) >> $MKFILE.tmp
+}
+
+#----------------------------#
+get_package_tarball_name() { #
+#----------------------------#
+  local script_name=$1
+
+   # The use of 'head' is necessary to limit the return value to the FIRST match..
+   # hopefully this will not cause problems.
+   #
+   case $script_name in
+     tcl)   echo $(grep "^tcl" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
+     *)     echo $(grep "^$script_name-[[:digit:]]" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
+   esac
+
+}
 
 #----------------------------------#
@@ -266,4 +317,24 @@
 
 #----------------------------------#
+wrt_unpack_clfs() {                # Unpack and set 'ROOT' var
+#----------------------------------#
+  local FILE=$1
+  local optSAVE_PREVIOUS=$2
+
+  if [ "${optSAVE_PREVIOUS}" != "1" ]; then
+    wrt_remove_existing_dirs "$FILE"
+  fi
+(
+cat << EOF
+	@\$(call unpack,$FILE)
+	@ROOT=\`head -n1 \$(MOUNT_PT)\$(SRC)/\$(PKG_LST) | sed 's@^./@@;s@/.*@@'\` && \\
+	echo "export PKGDIR=\$(MOUNT_PT)\$(SRC)/\$\$ROOT" > envars && \\
+	chown -R clfs \$(MOUNT_PT)\$(SRC)/\$\$ROOT
+EOF
+) >> $MKFILE.tmp
+}
+
+
+#----------------------------------#
 wrt_unpack2() {                    #
 #----------------------------------#
@@ -361,4 +432,32 @@
 cat << EOF
 	@( time { export LFS=\$(MOUNT_PT) && ${PROGNAME}-commands/$file >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
+	echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/$this_script
+EOF
+) >> $MKFILE.tmp
+}
+
+
+#----------------------------------#
+wrt_run_as_clfs_su() {             # Execute script inside time { }, footer to log file
+#----------------------------------#
+  local this_script=$1
+  local file=$2
+(
+cat << EOF
+	@( time { su - clfs -c "source /home/clfs/.bashrc && $JHALFSDIR/${PROGNAME}-commands/$file" >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
+	echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/$this_script
+EOF
+) >> $MKFILE.tmp
+}
+
+
+#----------------------------------#
+wrt_run_as_clfs_root() {           # Some scripts must be run as root..
+#----------------------------------#
+  local this_script=$1
+  local file=$2
+(
+cat << EOF
+	@( time { export CLFS=\$(MOUNT_PT) && ${PROGNAME}-commands/$file >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
 	echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/$this_script
 EOF
@@ -536,5 +635,5 @@
       rm -rf $BUILDDIR/{bin,boot,dev,etc,home,lib,media,mnt,opt,proc,root,sbin,srv,sys,tmp,tools,cross-tools,usr,var}
       echo -ne "Cleaning $JHALFSDIR...\n"
-      rm -rf $JHALFSDIR/{0*,1*,envars,sources-dir,*commands,logs,Makefile,*.xsl,makefile-functions,packages,patches}
+      rm -rf $JHALFSDIR/{0*,1*,envars,sources-dir,*commands,*logs,Makefile,*.xsl,makefile-functions,pkg_tarball_list,*.config,*.sh}
       echo -ne "Cleaning remainig extracted sources in $BUILDDIR/sources...\n"
       rm -rf `find $BUILDDIR/sources/* -maxdepth 0 -type d`
@@ -559,4 +658,5 @@
       hlfs) svn_root="HLFS" ;;
       clfs) svn_root="cross-lfs" ;;
+      clfs2) svn_root="cross-lfs" ;;
       *) echo "BOOK not defined in function <get_book>"
           exit 1 ;;
@@ -567,36 +667,32 @@
     if [ -d ${PROGNAME}-$LFSVRS ] ; then
       cd ${PROGNAME}-$LFSVRS
-      if LC_ALL=C svn up | grep -q At && test -d $JHALFSDIR/${PROGNAME}-commands && \
-      test -f $JHALFSDIR/packages ; then
+      if LC_ALL=C svn up | grep -q At && \
+         test -d $JHALFSDIR/${PROGNAME}-commands && \
+         test -f $JHALFSDIR/pkg_tarball_list ; then
+        # Set the canonical book version
         echo -ne "done\n"
-        # Set the canonical book version
         cd $JHALFSDIR
-        VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
+        case $PROGNAME in
+          clfs | clfs2)
+            VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //'  -e 's/<\/.*//') ;;
+          *)
+            VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //'  -e 's/<\/.*//')  ;;
+        esac
         get_sources
       else
         echo -ne "done\n"
-        # Set the canonical book version
-        cd $JHALFSDIR
-        VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
         extract_commands
       fi
     else
-      case $LFSVRS in
-        development)
-           svn co $SVN/${svn_root}/trunk/BOOK ${PROGNAME}-$LFSVRS >>$LOGDIR/$LOG 2>&1 ;;
-      esac
+      svn co $SVN/${svn_root}/${TREE} ${PROGNAME}-$LFSVRS >>$LOGDIR/$LOG 2>&1
       echo -ne "done\n"
-      # Set the canonical book version
-      cd $JHALFSDIR
-      VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
       extract_commands
     fi
+
   else
     echo -ne "Using $BOOK as book's sources ...\n"
-    # Set the canonical book version
-    cd $JHALFSDIR
-    VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
     extract_commands
   fi
+  echo -ne " Document version ${L_arrow}${BOLD}${VERSION}${R_arrow}\n"
 }
 
@@ -610,5 +706,10 @@
 
   cd $JHALFSDIR
-  VERSION=`grep "ENTITY version " $BOOK/general.ent | sed 's@<!ENTITY version "@@;s@">@@'`
+  case $PROGNAME in
+    clfs | clfs2 )
+      VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //'  -e 's/<\/.*//') ;;
+    *)
+      VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //'  -e 's/<\/.*//')  ;;
+  esac
 
   # Start clean
@@ -634,4 +735,17 @@
                  -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
       ;;
+
+    clfs2)
+        echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
+        xsltproc --nonet \
+                 --xinclude \
+                 --stringparam testsuite $TEST \
+                 --stringparam vim-lang $VIMLANG \
+                 --stringparam timezone $TIMEZONE \
+                 --stringparam page $PAGE \
+                 --stringparam lang $LANG \
+                 --stringparam keymap $KEYMAP \
+                 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
+      ;;
     hlfs)
         echo -n " ${L_arrow}${BOLD}$MODEL${R_arrow} HLFS libc implementation"
@@ -668,13 +782,35 @@
 
   # Create the packages file. We need it for proper Makefile creation
-  rm -f packages
-  echo -n "Creating <${PROGNAME}> specific packages file"
-  grep "\-version " $BOOK/packages.ent | sed -e 's@<!ENTITY @@' \
-                                             -e 's@">@"@' > packages
-  echo " ...OK"
+  create_package_list
 
   # Done. Moving on...
   get_sources
 }
+
+#----------------------------#
+create_package_list() {      #
+#----------------------------#
+
+  # Create the packages file. We need it for proper Makefile creation
+  rm -f pkg_tarball_list
+  echo -n "Creating <${PROGNAME}> list of tarball names for $BOOK $ARCH"
+  case ${PROGNAME} in
+    clfs | clfs2)
+        xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
+                 $BOOK/materials/${ARCH}-chapter.xml >>$LOGDIR/$LOG 2>&1
+      ;;
+    hlfs)
+        xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
+                 $BOOK/chapter04/chapter04.xml >>$LOGDIR/$LOG 2>&1
+      ;;
+    lfs)
+        xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
+                 $BOOK/chapter03/chapter03.xml >>$LOGDIR/$LOG 2>&1
+      ;;
+  esac
+  echo " ...OK"
+
+}
+
 
 #----------------------------#
@@ -794,11 +930,10 @@
 
   if [[ -s MISSING_FILES.DMP ]]; then
-    echo  -e "\n\n${tab_}${RED} One or more files were not retrieved or have a bad MD5SUMS chechsum.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n"
-      # Do not allow the automatic exection of the Makefile.
+    echo  -e "\n\n${tab_}${RED} One or more files were not retrieved or have bad MD5SUMS.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n"
+      # Do not allow the automatic execution of the Makefile.
     echo "${tab_}${BOLD}${RED}*** ${YELLOW}Automatic execution of the generated makefile has been inhibited. ${RED}***${OFF}${nl_}"
     RUNMAKE=0
   fi
 }
-
 
 #----------------------------#
@@ -816,4 +951,12 @@
         echo " ...OK"
       ;;
+    clfs2)
+        echo -n "Creating CLFS2 <${ARCH}> specific URLs file"
+        xsltproc --nonet --xinclude \
+                 --stringparam server $SERVER \
+                 -o $BUILDDIR/sources/urls.lst urls.xsl \
+                 $BOOK/materials/$ARCH-chapter.xml >>$LOGDIR/$LOG 2>&1
+        echo " ...OK"
+      ;;
     hlfs)
         echo -n "Creating HLFS <${MODEL}> specific URLs file"
Index: common/config
===================================================================
--- common/config	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ common/config	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -17,4 +17,6 @@
 
 #=== Getting packages ===
+#    Files will be retrieved from the local archive SRC_ARCHIVE 
+#    (if defined) or the 'net and will be stored in $BUILDDIR/sources
 #--- Download the source packages 0(no)/1(yes)
 GETPKG=0
@@ -31,5 +33,5 @@
 
 #=== Build options ===
-#--- Run the makefile at the end  0(no)/1(yes)
+#--- Automatically run the makefile once it has been created  0(no)/1(yes)
 RUNMAKE=0
 
Index: common/func_compare.sh
===================================================================
--- common/func_compare.sh	(revision 1504208b7b54f90c86e0a03e0057a143a66af921)
+++ common/func_compare.sh	(revision 3b63c8c196c5e8988cd6306bc7bd8b09f0e80b36)
@@ -35,6 +35,4 @@
 
   echo -e "\nsystem_build_$RUN: $PREV_IT $system_build" >> $MKFILE.tmp
-  PREV=system_build_$RUN
-
 }
 
@@ -113,4 +111,5 @@
 	popd 1> /dev/null
 	@touch \$@ && \\
+        sleep .25 && \\
 	echo " "\$(BOLD)Target \$(BLUE)\$@ \$(BOLD)OK && \\
 	echo --------------------------------------------------------------------------------\$(WHITE)
